subset {base} | R Documentation

## Subsetting Vectors and Data Frames

### Description

Return subsets of vectors or data frames which meet conditions.

### Usage

    subset(x, ...)
    subset.default(x, subset)
    subset.data.frame(x, subset, select)

### Arguments

`x` | object to be subsetted
`...` | how to subset, depends on object
`subset` | logical expression
`select` | expression, indicating variables to select from a data frame

### Details

For ordinary vectors, the result is simply `x[subset & !is.na(subset)]`.

For dataframes, the `subset` argument works similarly on the rows. Note that `subset` will be evaluated in the dataframe.

The `select` argument exists only for dataframes. It works by first replacing variable names in the selection expression with the corresponding column numbers in the dataframe and then using the resulting integer vector to index the columns. This allows the use of the standard indexing conventions so that for examples ranges of variables can be specified easily.

### Value

Selected rows and columns of the object `x`.

### Author(s)

Peter Dalgaard

### See Also

`[`, `transform`

### Examples

    data(airquality)
    subset(airquality, Temp > 80, select = c(Ozone, Temp))
    subset(airquality, Day == 1, select = -Temp)
    subset(airquality, select = Ozone:Wind)

    attach(airquality)
    subset(Ozone, Temp > 80)

[Package Contents]